/*
 * Note: this file originally auto-generated by mib2c using
 *        : mib2c.brcm.scalar.conf $
 */

#include <net-snmp/net-snmp-config.h>
#include <net-snmp/net-snmp-includes.h>
#include <net-snmp/agent/net-snmp-agent-includes.h>
#include "system.h"

/*
 * Define the OID pointer to the top of the mib tree that we're
 * registering underneath
 */
oid             system_module_oid[] = { 1, 3, 6, 1, 2, 1, 1 };
int             system_module_oid_len =
    sizeof(system_module_oid) / sizeof(oid);
int             system_module_count = 0;


/** Initializes the system module */
void
init_system(void)
{
    static oid      sysObjectID_oid[] = { 1, 3, 6, 1, 2, 1, 1, 2, 0 };
    static oid      sysLocation_oid[] = { 1, 3, 6, 1, 2, 1, 1, 6, 0 };
    static oid      sysORLastChange_oid[] = { 1, 3, 6, 1, 2, 1, 1, 8, 0 };
    static oid      sysServices_oid[] = { 1, 3, 6, 1, 2, 1, 1, 7, 0 };
    static oid      sysContact_oid[] = { 1, 3, 6, 1, 2, 1, 1, 4, 0 };
    static oid      sysName_oid[] = { 1, 3, 6, 1, 2, 1, 1, 5, 0 };
    static oid      sysDescr_oid[] = { 1, 3, 6, 1, 2, 1, 1, 1, 0 };
    static oid      sysUpTime_oid[] = { 1, 3, 6, 1, 2, 1, 1, 3, 0 };

    DEBUGMSGTL(("system", "Initializing\n"));
    printf("(TC) now in init_system\n");
    netsnmp_register_read_only_instance(netsnmp_create_handler_registration
                                        ("sysObjectID",
                                         get_sysObjectID,
                                         sysObjectID_oid,
                                         OID_LENGTH(sysObjectID_oid),
                                         HANDLER_CAN_RONLY));
    netsnmp_register_instance(netsnmp_create_handler_registration
                              ("sysLocation",
                               do_sysLocation,
                               sysLocation_oid,
                               OID_LENGTH(sysLocation_oid),
                               HANDLER_CAN_RWRITE));
    netsnmp_register_read_only_instance(netsnmp_create_handler_registration
                                        ("sysORLastChange",
                                         get_sysORLastChange,
                                         sysORLastChange_oid,
                                         OID_LENGTH(sysORLastChange_oid),
                                         HANDLER_CAN_RONLY));
    netsnmp_register_read_only_instance(netsnmp_create_handler_registration
                                        ("sysServices",
                                         get_sysServices,
                                         sysServices_oid,
                                         OID_LENGTH(sysServices_oid),
                                         HANDLER_CAN_RONLY));
    netsnmp_register_instance(netsnmp_create_handler_registration
                              ("sysContact",
                               do_sysContact,
                               sysContact_oid,
                               OID_LENGTH(sysContact_oid),
                               HANDLER_CAN_RWRITE));
    netsnmp_register_instance(netsnmp_create_handler_registration
                              ("sysName",
                               do_sysName,
                               sysName_oid,
                               OID_LENGTH(sysName_oid),
                               HANDLER_CAN_RWRITE));
    netsnmp_register_read_only_instance(netsnmp_create_handler_registration
                                        ("sysDescr",
                                         get_sysDescr,
                                         sysDescr_oid,
                                         OID_LENGTH(sysDescr_oid),
                                         HANDLER_CAN_RONLY));
    netsnmp_register_read_only_instance(netsnmp_create_handler_registration
                                        ("sysUpTime",
                                         get_sysUpTime,
                                         sysUpTime_oid,
                                         OID_LENGTH(sysUpTime_oid),
                                         HANDLER_CAN_RONLY));

    printf("(TC) now in init_system - finished\n");
}

int
get_sysObjectID(netsnmp_mib_handler *handler,
                netsnmp_handler_registration *reginfo,
                netsnmp_agent_request_info *reqinfo,
                netsnmp_request_info *requests)
{
    /*
     * We are never called for a GETNEXT if it's registered as a
     * "instance", as it's "magically" handled for us.  
     */

    /*
     * a instance handler also only hands us one request at a time, so
     * we don't need to loop over a list of requests; we'll only get one. 
     */

    int             retVal = SNMP_ERR_NOERROR;

    u_char          sysObjectID_var[STRINGMAX];
    size_t          sysObjectID_varLen;

    switch (reqinfo->mode) {

    case MODE_GET:
        
        printf("(TC) getsysObjectID do the v2Get!!!!!!!!!!!!!!!!!!!!!!!!\n");
        retVal =
            v2Get(requests->requestvb->name,
                  requests->requestvb->name_length, sysObjectID_var,
                  &sysObjectID_varLen, reqinfo);
        if (retVal == SNMP_ERR_NOERROR)
            snmp_set_var_typed_value(requests->requestvb, ASN_OBJECT_ID,
                                     sysObjectID_var, sysObjectID_varLen);
        else
            netsnmp_set_request_error(reqinfo, requests, retVal);
        break;


    default:
        /*
         * we should never get here, so this is a really bad error 
         */
        return SNMP_ERR_GENERR;
    }

    return retVal;
}

int
do_sysLocation(netsnmp_mib_handler *handler,
               netsnmp_handler_registration *reginfo,
               netsnmp_agent_request_info *reqinfo,
               netsnmp_request_info *requests)
{
    /*
     * We are never called for a GETNEXT if it's registered as a
     * "instance", as it's "magically" handled for us.  
     */

    /*
     * a instance handler also only hands us one request at a time, so
     * we don't need to loop over a list of requests; we'll only get one. 
     */

    int             retVal = SNMP_ERR_NOERROR;

    u_char          sysLocation_var[STRINGMAX];
    size_t          sysLocation_varLen;
    printf("(TC) getsysLocation do the v2Get!!!!!!!!!!!!!!!!!!!!!!!!\n");
         
    switch (reqinfo->mode) {

    case MODE_GET:
        retVal =
            v2Get(requests->requestvb->name,
                  requests->requestvb->name_length, sysLocation_var,
                  &sysLocation_varLen, reqinfo);
        if (retVal == SNMP_ERR_NOERROR)
            snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                     sysLocation_var, sysLocation_varLen);
        else
            netsnmp_set_request_error(reqinfo, requests, retVal);
        break;

        /*
         * SET REQUEST
         *
         */
    case MODE_SET_RESERVE1:
        if (requests->requestvb->type != ASN_OCTET_STR) {
            netsnmp_set_request_error(reqinfo, requests,
                                      SNMP_ERR_WRONGTYPE);
            retVal = SNMP_ERR_WRONGTYPE;
        } else {
            retVal = v2Test(requests->requestvb->name,
                            requests->requestvb->name_length,
                            requests->requestvb->val.string,
                            requests->requestvb->val_len,
                            requests->requestvb->type, reqinfo);
            if (retVal != SNMP_ERR_NOERROR)
                netsnmp_set_request_error(reqinfo, requests, retVal);
        }
        break;

    case MODE_SET_RESERVE2:
        break;

    case MODE_SET_FREE:
        break;

    case MODE_SET_ACTION:
        break;

    case MODE_SET_COMMIT:
        /*
         * really do the set! 
         */
        retVal = v2Set(requests->requestvb->name,
                       requests->requestvb->name_length,
                       requests->requestvb->val.string,
                       requests->requestvb->val_len,
                       requests->requestvb->type, reqinfo);
        if (retVal != SNMP_ERR_NOERROR)
            netsnmp_set_request_error(reqinfo, requests, retVal);
        break;

    case MODE_SET_UNDO:
        /*
         * Can't undo V2 sets! 
         */
        break;

    default:
        /*
         * we should never get here, so this is a really bad error 
         */
        return SNMP_ERR_GENERR;
    }

    return retVal;
}

int
get_sysORLastChange(netsnmp_mib_handler *handler,
                    netsnmp_handler_registration *reginfo,
                    netsnmp_agent_request_info *reqinfo,
                    netsnmp_request_info *requests)
{
    /*
     * We are never called for a GETNEXT if it's registered as a
     * "instance", as it's "magically" handled for us.  
     */

    /*
     * a instance handler also only hands us one request at a time, so
     * we don't need to loop over a list of requests; we'll only get one. 
     */

    int             retVal = SNMP_ERR_NOERROR;

    u_char          sysORLastChange_var[STRINGMAX];
    size_t          sysORLastChange_varLen;

    switch (reqinfo->mode) {

    case MODE_GET:
        retVal =
            v2Get(requests->requestvb->name,
                  requests->requestvb->name_length, sysORLastChange_var,
                  &sysORLastChange_varLen, reqinfo);
        if (retVal == SNMP_ERR_NOERROR)
            snmp_set_var_typed_value(requests->requestvb, ASN_TIMETICKS,
                                     sysORLastChange_var,
                                     sysORLastChange_varLen);
        else
            netsnmp_set_request_error(reqinfo, requests, retVal);
        break;


    default:
        /*
         * we should never get here, so this is a really bad error 
         */
        return SNMP_ERR_GENERR;
    }

    return retVal;
}

int
get_sysServices(netsnmp_mib_handler *handler,
                netsnmp_handler_registration *reginfo,
                netsnmp_agent_request_info *reqinfo,
                netsnmp_request_info *requests)
{
    /*
     * We are never called for a GETNEXT if it's registered as a
     * "instance", as it's "magically" handled for us.  
     */

    /*
     * a instance handler also only hands us one request at a time, so
     * we don't need to loop over a list of requests; we'll only get one. 
     */

    int             retVal = SNMP_ERR_NOERROR;

    u_char          sysServices_var[STRINGMAX];
    size_t          sysServices_varLen;
    printf("(TC) getsysServices do the v2Get!!!!!!!!!!!!!!!!!!!!!!!!\n");

    switch (reqinfo->mode) {

    case MODE_GET:
        retVal =
            v2Get(requests->requestvb->name,
                  requests->requestvb->name_length, sysServices_var,
                  &sysServices_varLen, reqinfo);
        if (retVal == SNMP_ERR_NOERROR)
            snmp_set_var_typed_value(requests->requestvb, ASN_INTEGER,
                                     sysServices_var, sysServices_varLen);
        else
            netsnmp_set_request_error(reqinfo, requests, retVal);
        break;


    default:
        /*
         * we should never get here, so this is a really bad error 
         */
        return SNMP_ERR_GENERR;
    }

    return retVal;
}

int
do_sysContact(netsnmp_mib_handler *handler,
              netsnmp_handler_registration *reginfo,
              netsnmp_agent_request_info *reqinfo,
              netsnmp_request_info *requests)
{
    /*
     * We are never called for a GETNEXT if it's registered as a
     * "instance", as it's "magically" handled for us.  
     */

    /*
     * a instance handler also only hands us one request at a time, so
     * we don't need to loop over a list of requests; we'll only get one. 
     */

    int             retVal = SNMP_ERR_NOERROR;

    u_char          sysContact_var[STRINGMAX];
    size_t          sysContact_varLen;
    printf("(TC) getsysContact do the v2Get!!!!!!!!!!!!!!!!!!!!!!!!\n");

    switch (reqinfo->mode) {

    case MODE_GET:
        retVal =
            v2Get(requests->requestvb->name,
                  requests->requestvb->name_length, sysContact_var,
                  &sysContact_varLen, reqinfo);
        if (retVal == SNMP_ERR_NOERROR)
            snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                     sysContact_var, sysContact_varLen);
        else
            netsnmp_set_request_error(reqinfo, requests, retVal);
        break;

        /*
         * SET REQUEST
         *
         */
    case MODE_SET_RESERVE1:
        if (requests->requestvb->type != ASN_OCTET_STR) {
            netsnmp_set_request_error(reqinfo, requests,
                                      SNMP_ERR_WRONGTYPE);
            retVal = SNMP_ERR_WRONGTYPE;
        } else {
            retVal = v2Test(requests->requestvb->name,
                            requests->requestvb->name_length,
                            requests->requestvb->val.string,
                            requests->requestvb->val_len,
                            requests->requestvb->type, reqinfo);
            if (retVal != SNMP_ERR_NOERROR)
                netsnmp_set_request_error(reqinfo, requests, retVal);
        }
        break;

    case MODE_SET_RESERVE2:
        break;

    case MODE_SET_FREE:
        break;

    case MODE_SET_ACTION:
        break;

    case MODE_SET_COMMIT:
        /*
         * really do the set! 
         */
        retVal = v2Set(requests->requestvb->name,
                       requests->requestvb->name_length,
                       requests->requestvb->val.string,
                       requests->requestvb->val_len,
                       requests->requestvb->type, reqinfo);
        if (retVal != SNMP_ERR_NOERROR)
            netsnmp_set_request_error(reqinfo, requests, retVal);
        break;

    case MODE_SET_UNDO:
        /*
         * Can't undo V2 sets! 
         */
        break;

    default:
        /*
         * we should never get here, so this is a really bad error 
         */
        return SNMP_ERR_GENERR;
    }

    return retVal;
}

int
do_sysName(netsnmp_mib_handler *handler,
           netsnmp_handler_registration *reginfo,
           netsnmp_agent_request_info *reqinfo,
           netsnmp_request_info *requests)
{
    /*
     * We are never called for a GETNEXT if it's registered as a
     * "instance", as it's "magically" handled for us.  
     */

    /*
     * a instance handler also only hands us one request at a time, so
     * we don't need to loop over a list of requests; we'll only get one. 
     */

    int             retVal = SNMP_ERR_NOERROR;

    u_char          sysName_var[STRINGMAX];
    size_t          sysName_varLen;
    printf("(TC) getsysName do the v2Get!!!!!!!!!!!!!!!!!!!!!!!!\n");

    switch (reqinfo->mode) {

    case MODE_GET:
        retVal =
            v2Get(requests->requestvb->name,
                  requests->requestvb->name_length, sysName_var,
                  &sysName_varLen, reqinfo);
        if (retVal == SNMP_ERR_NOERROR)
            snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                     sysName_var, sysName_varLen);
        else
            netsnmp_set_request_error(reqinfo, requests, retVal);
        break;

        /*
         * SET REQUEST
         *
         */
    case MODE_SET_RESERVE1:
        if (requests->requestvb->type != ASN_OCTET_STR) {
            netsnmp_set_request_error(reqinfo, requests,
                                      SNMP_ERR_WRONGTYPE);
            retVal = SNMP_ERR_WRONGTYPE;
        } else {
            retVal = v2Test(requests->requestvb->name,
                            requests->requestvb->name_length,
                            requests->requestvb->val.string,
                            requests->requestvb->val_len,
                            requests->requestvb->type, reqinfo);
            if (retVal != SNMP_ERR_NOERROR)
                netsnmp_set_request_error(reqinfo, requests, retVal);
        }
        break;

    case MODE_SET_RESERVE2:
        break;

    case MODE_SET_FREE:
        break;

    case MODE_SET_ACTION:
        break;

    case MODE_SET_COMMIT:
        /*
         * really do the set! 
         */
        retVal = v2Set(requests->requestvb->name,
                       requests->requestvb->name_length,
                       requests->requestvb->val.string,
                       requests->requestvb->val_len,
                       requests->requestvb->type, reqinfo);
        if (retVal != SNMP_ERR_NOERROR)
            netsnmp_set_request_error(reqinfo, requests, retVal);
        break;

    case MODE_SET_UNDO:
        /*
         * Can't undo V2 sets! 
         */
        break;

    default:
        /*
         * we should never get here, so this is a really bad error 
         */
        return SNMP_ERR_GENERR;
    }

    return retVal;
}

int
get_sysDescr(netsnmp_mib_handler *handler,
             netsnmp_handler_registration *reginfo,
             netsnmp_agent_request_info *reqinfo,
             netsnmp_request_info *requests)
{
    /*
     * We are never called for a GETNEXT if it's registered as a
     * "instance", as it's "magically" handled for us.  
     */

    /*
     * a instance handler also only hands us one request at a time, so
     * we don't need to loop over a list of requests; we'll only get one. 
     */

    int             retVal = SNMP_ERR_NOERROR;

    u_char          sysDescr_var[STRINGMAX];
    size_t          sysDescr_varLen;
    printf("(TC) getsysDescr do the v2Get!!!!!!!!!!!!!!!!!!!!!!!!\n");

    switch (reqinfo->mode) {
    
    case MODE_GET:
        retVal =
            v2Get(requests->requestvb->name,
                  requests->requestvb->name_length, sysDescr_var,
                  &sysDescr_varLen, reqinfo);
        if (retVal == SNMP_ERR_NOERROR)
        {
            printf("v2Get retVal NO error\n");
            snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                     sysDescr_var, sysDescr_varLen);
        }
        else
        {
            printf("v2Get retVal ERROR\n");
            netsnmp_set_request_error(reqinfo, requests, retVal);
        }
        break;


    default:
        /*
         * we should never get here, so this is a really bad error 
         */
        return SNMP_ERR_GENERR;
    }

    return retVal;
}

int
get_sysUpTime(netsnmp_mib_handler *handler,
              netsnmp_handler_registration *reginfo,
              netsnmp_agent_request_info *reqinfo,
              netsnmp_request_info *requests)
{
    /*
     * We are never called for a GETNEXT if it's registered as a
     * "instance", as it's "magically" handled for us.  
     */

    /*
     * a instance handler also only hands us one request at a time, so
     * we don't need to loop over a list of requests; we'll only get one. 
     */

    int             retVal = SNMP_ERR_NOERROR;

    u_char          sysUpTime_var[STRINGMAX];
    size_t          sysUpTime_varLen;
    printf("(TC) getsysUpTime!!!!!!!!!!!!!!!!!!!!!!!!\n");

    switch (reqinfo->mode) {

    case MODE_GET:
        retVal =
            v2Get(requests->requestvb->name,
                  requests->requestvb->name_length, sysUpTime_var,
                  &sysUpTime_varLen, reqinfo);
        if (retVal == SNMP_ERR_NOERROR)
            snmp_set_var_typed_value(requests->requestvb, ASN_TIMETICKS,
                                     sysUpTime_var, sysUpTime_varLen);
        else
            netsnmp_set_request_error(reqinfo, requests, retVal);
        break;


    default:
        /*
         * we should never get here, so this is a really bad error 
         */
        return SNMP_ERR_GENERR;
    }

    return retVal;
}
